{{ 99 - Halloween-Remote.  
  
This program operates the Halloween Display using a IR Remote.
Based on the Sony_IR_Decoder.spin by John B. Fisher
Based on ideas in "IR Remote for the BoeBot" by Andy Lindsay.

}} 
CON
'Set system speed to 80MHZ
     _clkmode = xtal1 + pll16x      
     _xinfreq = 5_000_000

'Pin Assingments    
 HeadServo    = 19
 JawServo     = 18
 PIR_Pin      = 16
 ColorPal     = 14  
 IR_Pin       = 12
 Reye_R       =  0
 Reye_C       =  1
 Reye_L       =  2
 Leye_R       =  3
 Leye_C       =  4
 Leye_L       =  5
 _dopin       = 22     'Pins for the MicroSD Card Slot - See PropBOE datasheet
 _clkpin      = 23
 _dipin       = 24
 _cspin       = 25
 _cdpin       = -1 ' -1 if unused.
 _wppin       = -1 ' -1 if unused.

'Other constants for WAV player
  _rtcres1 = -1 ' -1 always.
  _rtcres2 = -1 ' -1 always.
  _rtcres3 = -1 ' -1 always.

  _lpin = 26 ' -1 if unused.   'Pins connected to phone jack on PropBOE
  _rpin = 27 ' -1 if unused.

  _volume = 80 ' Default volume.

  _ditherEnable = true ' "true" or "false" please.
  _ditherLevel = 4 ' 0 = Most Dither ... 31 = Least Dither.
VAR
     Long stack1[50]                 ' Stack for 2nd BS2_Functions Cog 
     Byte Message
     Long spinPlayerStack[100]
OBJ
     BS2   : "BS2_Functions"                                ' Create BS2 Object
     Servos: "PropBOE Servos"                               ' Servo Controler
     timing: "Timing"                                       ' Timing commands
     pin   : "Input Output Pins"                            ' I/O convenience methods
     dac   : "WAV-Player_DACEngine.spin"                    ' WAV file player
     serial: "Simple_Serial"                                ' Color Pal Control                                            
PUB Init
  dac.FATEngineStart(_dopin, _clkpin, _dipin, _cspin, _wppin, _cdpin, _rtcres1, _rtcres2, _rtcres3)
  dac.DACEngineStart(constant(_lpin | (not(not(_ditherEnable)))), constant(_rpin | (not(not(_ditherEnable)))), _volume)
  ' Above Never fail - no need to check return value.    
  if(_ditherEnable)
    dac.DACDitherEngineStart(_lpin, _rpin, _ditherLevel) ' Never fails - no need to check return value.
  Timing.pause(5_000)
  BS2.start (31,30)              ' Initialize BS2 Object, Rx and Tx pins for DEBUG
  BS2.DEBUG_STR(string("Starting"))
  BS2.Debug_Char(13)
  StartCP(ColorPal)                'Initialize ColorPal
  HeadRight
  timing.pause(500)
  HeadLeft
  timing.pause(500)
  HeadCenter
  JawClose
  EYES_ON 
  CP_Flicker
  MonitorRemote
PUB GetMessage  |  Pulse[7]
{{This section reads the first 7 bits of a remote controller using the Sony
  protocol}}
    Pulse[0] := 0
    Pulse[1] := 0    
    Pulse[2] := 0
    Pulse[3] := 0
    Pulse[4] := 0
    Pulse[5] := 0
    Pulse[6] := 0            
    Message  := 255
    Repeat until Message < 255 
      Pulse[0] := (BS2.RCTIME(IR_Pin, 0))/2         
        if (Pulse[0] > 975) and (Pulse[0] < 1425)
            Pulse[0] :=  BS2.PULSIN(IR_Pin,0)
            Pulse[1] :=  BS2.PULSIN(IR_Pin,0)
            Pulse[2] :=  BS2.PULSIN(IR_Pin,0)
            Pulse[3] :=  BS2.PULSIN(IR_Pin,0)
            Pulse[4] :=  BS2.PULSIN(IR_Pin,0)
            Pulse[5] :=  BS2.PULSIN(IR_Pin,0)
            Pulse[6] :=  BS2.PULSIN(IR_Pin,0)
             if Pulse[0] < 400                        ' convert long and short pulses to
                message := 0                         ' bits in message variable.
             else
                message := 1
            if Pulse[1] > 400    
                message := message + 2
            if Pulse[2] > 400    
                message := message + 4
            if Pulse[3] > 400    
                message := message + 8
            if Pulse[4] > 400    
                message := message + 16
            if Pulse[5] > 400    
                message := message + 32
            if Pulse[6] > 400    
                message := message + 64
            message := message + 1                   ' make message = IR Remote numerical button
            if message == 10                         ' special case
                message := 0

Pub MonitorRemote  
  repeat
    GetMessage
     Case Message
        1  : Play_Corpse
        117: JawClose 
        118: JawOpen
        52 : HeadRight
        53 : HeadLeft 
        102: HeadCenter
     BS2.DEBUG_STR(string("IR Message: "))
     BS2.DEBUG_DEC(Message)
     BS2.Debug_Char(13)
     timing.pause(500)
PRI HeadCenter
    Servos.Set(HeadServo,0)
PRI HeadRight
    Servos.Set(HeadServo,300)
PRI HeadLeft
    Servos.Set(HeadServo,-300)             
PRI JawOpen
    Servos.set(JawServo,-200)
PRI JawTalk
    Servos.set(JawServo,690)           
PRI JawClose
    Servos.set(JawServo,800)
PRI Eyes_ON
    Pin.high(Reye_C)
    pin.high(Leye_C)
PRI Eyes_OFF
    Pin.low(Reye_C)
    pin.low(Leye_C)
PRI Eyes_Blink
    Eyes_on
    timing.pause(300)
    Eyes_off
    timing.pause(500)
    Eyes_on
Pri StartCP(pal_pin) | loop, baud
  outa[pal_pin]:=0 ' set pin to low
  dira[pal_pin]:=0 ' direction input
  loop:=0
  baud:=4800
  'reset the ColorPAL and put it in direct mode
  repeat while (loop==0)
    if (ina[pal_pin]<>0)
      dira[pal_pin]:=1 ' output
      outa[pal_pin]:=0 ' set pin to low
      waitcnt(cnt+80*CLKFREQ/(1000)) ' wait 80 ms
      dira[pal_pin]:=1
      waitcnt(cnt+10*CLKFREQ/(1000))
      loop:=1
  serial.init(pal_pin, pal_pin, baud)
Pri CP_Flicker
  serial.str(string("= (00 ?05 Y t09 F t05 r404000 t09 )!"))
PRI PlayWave01 
    dac.playWAVFile(string("Corpse.wav"))
PRI Play_Corpse
  if not dac.wavePlayerState               ' Make sure a file is not playing
      cognew(PlayWave01, @spinPlayerStack) ' Startup separate process
      timing.pause(3000)
      serial.str(string("= R !"))          ' Turn LED Red
      repeat while not dac.wavePlayerState
      HeadLeft
      Repeat 3
        JawOpen
        Timing.pause(100)
        JawTalk
        Timing.pause(100)
      JawClose
      HeadCenter
      Repeat Until dac.fileSamplePosition > 521_000     'Start of 1st Verse
      JawOpen
      timing.pause(500)
      JawClose
      JawSingCorpse(6)
      JawClose
      Repeat Until dac.fileSamplePosition > 1_789_256   'Start of 2nd Verse
      JawOpen
      timing.pause(500)
      JawClose
      JawSingCorpse(9)
      JawClose

      Repeat while dac.wavePlayerState
      serial.str(string("= G !"))          ' Turn LED Green
Pri JawSingCorpse(Verses)
      Repeat Verses
        Repeat 5
          JawOpen
          Timing.pause(100)
          JawTalk
          Timing.pause(200)
          Jawclose
        timing.pause(400)
Pri Eyes_Beat | i
  i:= %001001
    repeat 2
      pin.Outs(5,0,i)
      i := i<<1
      timing.Pause(200)
    repeat 2
      pin.Outs(5,0,i)
      i := i>>1
      timing.Pause(200)
  i:=%010010
      pin.Outs(5,0,i)